#!/usr/bin/perl -I/usr/local/sauron -w
#
#
#=================================
# project: Sauron managment
# script:  fix_hostname_option.pl
# version: 2.0\n";
#
# Oprava "option hostname" option.
# Nasteveni podle domenoveho jmena
#=================================


#------------------------
# zacatek Sauroniho kodu
#------------------------

require 5;
use Getopt::Long;
use Sauron::DB;
use Sauron::Util;
use Sauron::BackEnd;
use Sauron::Sauron;

load_config();

fatal("cannot find $PROG_DIR/runsql (invalid configuration?)")
unless (-x "$PROG_DIR/runsql");

db_connect();
  
#----------------------
# konec Sauroniho kodu
#----------------------

#nastaveni ID pro zony (POZOR zkontrolujte, zde to je skutecne)
$zcuID = 3;
$pefID = 6;
$fekID = 4;

mkdir TEMP;

print "Acquiring ID list ...\n";

`sudo -u postgres psql -c "select id, ref, dhcp from dhcp_entries" sauron > TEMP/id1.txt`;

#nastaveni jmen souboru
open(ID, "<TEMP/id1.txt");


print "Acquiring ID list ...\n";

`sudo -u postgres psql -c "select id, zone, domain from hosts" sauron > TEMP/id2.txt`;

#nastaveni jmen souboru
open(ID2, "<TEMP/id2.txt");
#---------------------------------------------------------------------------
	# Priprava pole obsahujiho usporadanou dvojici ID-domenove_jmeno
#---------------------------------------------------------------------------

print "Creating ID-domainname couples ...\n";

#nacteni dat
@iddata = <ID2>;
if ($#iddata == 0){
  print "Error: no ID detected.\n";
  exit(1);
}

#lepsi naformatovani ID=IP
@tempdata = ();
$rows=0;
foreach(@iddata){
  if ($rows<2){
    #vynechani hlavicky
    $rows += 1;
  }
  else{
    if (($_ =~ /\|/) == 1){
      $_ =~ /\|/;
      $part1 = $`;
      $part2 = $';
      $part2 =~ /\|/;
      $part2 = $`;
      $part3 = $';
      
      $part1 =~ /[^\s][^\s]*/;
      $part1 = $&;
      $part2 =~ /[^\s][^\s]*/;
      $part2 = $&;
      $part3 =~ /[^\s][^\s]*/;
      $part3 = $&;

      $zone = "UNKNOWN";
      if ($part2 == $zcuID){
        $zone = "zcu.cz"
      }
      if ($part2 == $pefID){
        $zone = "pef.zcu.cz"
      }
      if ($part2 == $fekID){
        $zone = "fek.zcu.cz"
      }
      push @tempdata, "$part1=$part3.$zone";
    }
  }
}
@iddata = @tempdata;
close(ID2);

#foreach(@iddata){
#  print "'$_'\n";
#}
#die;

print "Generating SQL commands ...\n";

#---------------------------------------------------------------------------
# Vygenerovani SQL prikazu ze vstupu
#---------------------------------------------------------------------------
@sql_lines = ();
$rows = 0;
foreach(<ID>){
  $rows += 1;
#  if (($rows % 100) == 0){
#    print "  $rows ";
#  }
  if ($rows<=2){
    #vynechani hlavicky
  }
  else{
    if (($_ =~ /\|/) == 1){
      $_ =~ /\|/;
      $id = $`;
      $ref = $';
      $ref =~ /\|/;
      $ref = $`;
      $entry = $';
    
      $id =~ /[0-9][0-9]*/;
      $id = $&;
      
      $ref =~ /[0-9][0-9]*/;
      $ref = $&;
  
      $entry =~ /[\s]*/;
      $entry = $';
      $entry =~ /\n$/;
      $entry = $`;
      
      if ($entry =~ /^option host-name/){
        $name = &get_name($ref);
        
        #print "ENTRY = $entry, ID = $id, REF = $ref\n";
	if ($name eq "-1"){
          print "$ref not found.\n";  
        }
        else{
          $insname = "option host-name \"$name\"";
      
          if ($entry =~ $insname) {
            #zaznam je spravny -> nic se nedeje
            #push @sql_lines, "SAME $insname";
            #print "$entry is OK\n";
          }
          else{
            #push @sql_lines, "$entry->$insname-(ID=$id REF-$ref)\n";
	    $entry =~ /".*"/;
	    $outname = $&;
	    $outname =~ /[^\"][^\"]*/;
	    $outname = $&;	    
            print "$outname -> $insname\n";
	    push @sql_lines, "update dhcp_entries set dhcp = '$insname' where (id = $id);\n";
          }
        }
      } #if entry = option host-name
    }
  }
# #print "$ip=$entry\n";
# $id = &get_id($ip); 
# if ($id == -1){
#   print "IP $ip not found.\n";  
# }
# else{
#   print "DHCP entry '$entry' added to IP $ip\n";
#   push @sql_lines, "insert into dhcp_entries (dhcp, type, ref) values ('$entry', 3, $id);\n";
# }
}

close(ID);


#foreach(@sql_lines){
#  print "$_";
#}
#die;
#---------------------------------------------------------------------------
# Priprava SQL prikazu pro pridani pozadovanych zaznamu
#---------------------------------------------------------------------------
open(SQL, ">TEMP/insert.sql");
foreach(@sql_lines){
  print SQL $_;
}
close(SQL);

print "Executing SQL commands ...\n";

$res=system("$PROG_DIR/runsql","TEMP/insert.sql");
fatal("failed") if ($res);

print "Host options were successfully fixed\n\n";
#---------------------------------------------------------------------------
# Podprogramy
#---------------------------------------------------------------------------
sub get_name{
  $search=$_[0];
  foreach(@iddata){
    $_ =~ /=/;
    $idcko = $`;
    $name = $';
    if ($idcko == $search){
      #prevod na format jako je v databazi
      return ($name);
    }
  }
  return("-1");
}


