#!/usr/bin/perl -I/usr/local/sauron -w
#
#
#=================================
# project: Sauron managing
# script:  set_info.pl
# version: 1.0\n";
#
# Pridani "info" do 
# databaze podle IP
#=================================

#------------------------
# zacatek Sauroniho kodu
#------------------------

require 5;
use Getopt::Long;
use Sauron::DB;
use Sauron::Util;
use Sauron::BackEnd;
use Sauron::Sauron;

load_config();

fatal("cannot find $PROG_DIR/runsql (invalid configuration?)")
unless (-x "$PROG_DIR/runsql");

db_connect();
  
#----------------------
# konec Sauroniho kodu
#----------------------

mkdir TEMP;

print "Acquiring ID list ...\n";
`psql -c "select host, ip from a_entries" sauron > TEMP/id1.txt`;

#nastaveni jmen souboru
open(ID, "<TEMP/id1.txt");

#---------------------------------------------------------------------------
# Priprava pole obsahujiho usporadanou dvojici ID-domainname
#---------------------------------------------------------------------------

#nacteni dat
@iddata = <ID>;
if ($#iddata == 0){
  print "Error: no ID detected.\n";
  exit(1);
}

#lepsi naformatovani ID=HW
@tempdata = ();
$rows=0;
foreach(@iddata){
  if ($rows<2){
    #vynechani hlavicky
    $rows += 1;
  }
  else{
    if (($_ =~ /\|/) == 1){
      $_ =~ /\|/;
      $part1 = $`;
      $part2 = $';

      $part1 =~ /[^\s][^\s]*/;
      $part1 = $&;
      $part2 =~ /[^\s][^\s]*/;
      $part2 = $&;
      push @tempdata, "$part1=$part2";
    }
  }
}
@iddata = @tempdata;

close(ID);

#foreach(@iddata){
#  print "'$_'\n";
#}
#die;

#---------------------------------------------------------------------------
# Vygenerovani SQL prikazu ze vstupu
#---------------------------------------------------------------------------
@sql_lines = ();
foreach(<>){
  $_ =~ /[\s][\s]*/;
  $inip = $`;
  $ininfo = $';

  $ininfo =~ /[^\n][^\n]*/;
  $ininfo=$&;
  $ininfo =~ /^\s*\"/;
  $ininfo = $';
  $ininfo =~ /\"\s*$/;
  $ininfo = $`;
  #$inip =~ /[^\"][^\"]*/;
  #$inip=$&;
  
  #print "'$inip=$ininfo'\n";
  
  $currentid = &get_id($inip);
  
  if ($currentid == -1){
    print "IP $inip not found.\n";
  }
  else{
    print "Info '$ininfo' added to IP $inip\n";
  push @sql_lines, "update hosts set info = '$ininfo' where (id = $currentid);\n";
  }
}


#---------------------------------------------------------------------------
# Priprava SQL prikazu pro pridani pozadovanych zaznamu
#---------------------------------------------------------------------------
print "Generating SQL commands ...\n";
open(SQL, ">TEMP/insert.sql");
foreach(@sql_lines){
  print SQL $_;
}
close(SQL);

print "Executing SQL commands ...\n";

$res=system("$PROG_DIR/runsql","TEMP/insert.sql");
fatal("failed") if ($res);

print "Host options were successfully inserted.\n\n";

#---------------------------------------------------------------------------
# Podprogramy
#---------------------------------------------------------------------------
sub get_id{
$hwsearch=$_[0];
foreach(@iddata){
  $_ =~ /=/;
  $id = $`;
  $hw = $';
  if ($hw eq $hwsearch){
    #print "$hw : $id\n";
    #prevod na format jako je v databazi
    return ($id);
  }
}
return(-1);
}
                                              
